import {
  ApiClient
} from "./chunk-HMYBKIZ5.js";
import {
  validateAPIKey
} from "./chunk-S4L4GIE4.js";
import {
  environmentToCrossmintBaseURL
} from "./chunk-RGTXIOAE.js";
import {
  __spreadValues
} from "./chunk-JPRRZPBL.js";

// src/apiClient/CrossmintApiClient.ts
var CrossmintApiClient = class extends ApiClient {
  constructor(crossmint, {
    internalConfig
  }) {
    const apiKeyValidationResult = validateAPIKey(crossmint.apiKey, internalConfig.apiKeyExpectations);
    if (!apiKeyValidationResult.isValid) {
      throw new Error(apiKeyValidationResult.message);
    }
    super();
    this.crossmint = crossmint;
    this.parsedAPIKey = apiKeyValidationResult;
    this.internalConfig = internalConfig;
  }
  get baseUrl() {
    if (this.crossmint.overrideBaseUrl) {
      return ApiClient.normalizePath(this.crossmint.overrideBaseUrl);
    }
    const baseUrl = environmentToCrossmintBaseURL(this.parsedAPIKey.environment);
    return ApiClient.normalizePath(baseUrl);
  }
  get authHeaders() {
    return __spreadValues({
      "x-api-key": this.crossmint.apiKey
    }, this.crossmint.jwt ? { Authorization: `Bearer ${this.crossmint.jwt}` } : {});
  }
};

export {
  CrossmintApiClient
};
//# sourceMappingURL=chunk-5JBLIRIR.js.map