import {
  __async,
  __spreadProps,
  __spreadValues
} from "./chunk-JPRRZPBL.js";

// src/apiClient/ApiClient.ts
var ApiClient = class _ApiClient {
  makeRequest(path, init) {
    return __async(this, null, function* () {
      return yield fetch(this.buildUrl(path), __spreadProps(__spreadValues({}, init), {
        headers: __spreadValues(__spreadValues({}, this.authHeaders), init.headers)
        // authHeaders intentionally first, in case sub class wants to override
      }));
    });
  }
  buildUrl(path) {
    return `${_ApiClient.normalizePath(this.baseUrl)}/${_ApiClient.normalizePath(path)}`;
  }
  get(path, params) {
    return __async(this, null, function* () {
      return yield this.makeRequest(path, __spreadProps(__spreadValues({}, params), { method: "GET" }));
    });
  }
  post(path, params) {
    return __async(this, null, function* () {
      return yield this.makeRequest(path, __spreadProps(__spreadValues({}, params), { method: "POST" }));
    });
  }
  put(path, params) {
    return __async(this, null, function* () {
      return yield this.makeRequest(path, __spreadProps(__spreadValues({}, params), { method: "PUT" }));
    });
  }
  delete(path, params) {
    return __async(this, null, function* () {
      return yield this.makeRequest(path, __spreadProps(__spreadValues({}, params), { method: "DELETE" }));
    });
  }
  patch(path, params) {
    return __async(this, null, function* () {
      return yield this.makeRequest(path, __spreadProps(__spreadValues({}, params), { method: "PATCH" }));
    });
  }
  static normalizePath(path) {
    path = path.startsWith("/") ? path.slice(1) : path;
    path = path.endsWith("/") ? path.slice(0, -1) : path;
    return path;
  }
};

export {
  ApiClient
};
//# sourceMappingURL=chunk-HMYBKIZ5.js.map