"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _chunk3LUTBWSJcjs = require('./chunk-3LUTBWSJ.cjs');


var _chunk6QQ54FMLcjs = require('./chunk-6QQ54FML.cjs');






var _chunkV7MQGQOHcjs = require('./chunk-V7MQGQOH.cjs');




var _chunkQZ5VZAXGcjs = require('./chunk-QZ5VZAXG.cjs');



var _chunkF45I5NLIcjs = require('./chunk-F45I5NLI.cjs');

// src/apiKey/validateAPIKey.ts
var _bs58 = require('bs58'); var _bs582 = _interopRequireDefault(_bs58);
var _tweetnacl = require('tweetnacl'); var _tweetnacl2 = _interopRequireDefault(_tweetnacl);

// src/apiKey/validateAPIKeyPrefix.ts
function validateAPIKeyPrefix(apiKey, expectations) {
  if (isOldAPIKey(apiKey)) {
    return {
      isValid: false,
      message: "Old API key format detected. Please create a new API key from the Crossmint console."
    };
  }
  const usageOrigin = getUsageOriginForKey(apiKey);
  if (usageOrigin == null) {
    return {
      isValid: false,
      message: `Malformed API key. Must start with '${_chunkQZ5VZAXGcjs.APIKeyUsageOriginPrefix.CLIENT}' or '${_chunkQZ5VZAXGcjs.APIKeyUsageOriginPrefix.SERVER}'.`
    };
  }
  if ((expectations == null ? void 0 : expectations.usageOrigin) != null && usageOrigin !== expectations.usageOrigin) {
    return {
      isValid: false,
      message: `Disallowed API key. You passed a ${usageOrigin} API key, but a ${expectations.usageOrigin} API key is required.`
    };
  }
  const environment = getEnvironmentForKey(apiKey);
  if (environment == null) {
    return {
      isValid: false,
      message: `Malformed API key. Must have a valid environment: '${_chunkQZ5VZAXGcjs.APIKeyEnvironmentPrefix.DEVELOPMENT}', '${_chunkQZ5VZAXGcjs.APIKeyEnvironmentPrefix.STAGING}' or '${_chunkQZ5VZAXGcjs.APIKeyEnvironmentPrefix.PRODUCTION}'.`
    };
  }
  if ((expectations == null ? void 0 : expectations.environment) != null && environment !== expectations.environment) {
    return {
      isValid: false,
      message: `Disallowed API key. You passed a ${environment} API key, but a ${expectations.environment} API key is required.`
    };
  }
  return {
    isValid: true,
    usageOrigin,
    environment,
    prefix: `${_chunk6QQ54FMLcjs.usageOriginToPrefix.call(void 0, usageOrigin)}_${environment}`
  };
}
function isOldAPIKey(apiKey) {
  return apiKey.startsWith("sk_live") || apiKey.startsWith("sk_test");
}
function getUsageOriginForKey(apiKey) {
  if (apiKey.startsWith(_chunkQZ5VZAXGcjs.APIKeyUsageOriginPrefix.CLIENT + "_")) {
    return _chunkQZ5VZAXGcjs.APIKeyUsageOrigin.CLIENT;
  } else if (apiKey.startsWith(_chunkQZ5VZAXGcjs.APIKeyUsageOriginPrefix.SERVER + "_")) {
    return _chunkQZ5VZAXGcjs.APIKeyUsageOrigin.SERVER;
  }
  return null;
}
function getEnvironmentForKey(apiKey) {
  const keyWithoutUsageOrigin = apiKey.slice(3);
  if (keyWithoutUsageOrigin.startsWith(_chunkQZ5VZAXGcjs.APIKeyEnvironmentPrefix.DEVELOPMENT + "_")) {
    return _chunkQZ5VZAXGcjs.APIKeyEnvironmentPrefix.DEVELOPMENT;
  } else if (keyWithoutUsageOrigin.startsWith(_chunkQZ5VZAXGcjs.APIKeyEnvironmentPrefix.STAGING + "_")) {
    return _chunkQZ5VZAXGcjs.APIKeyEnvironmentPrefix.STAGING;
  } else if (keyWithoutUsageOrigin.startsWith(_chunkQZ5VZAXGcjs.APIKeyEnvironmentPrefix.PRODUCTION + "_")) {
    return _chunkQZ5VZAXGcjs.APIKeyEnvironmentPrefix.PRODUCTION;
  }
  return null;
}

// src/apiKey/validateAPIKey.ts
function validateAPIKey(apiKey, expectations) {
  const prefixValidationResult = validateAPIKeyPrefix(apiKey, expectations);
  if (!prefixValidationResult.isValid) {
    return prefixValidationResult;
  }
  const { prefix } = prefixValidationResult;
  const { keyData, keyDataWithoutPrefix, signature } = decodeAPIKeyAndGetParts(apiKey, prefix);
  const isSignatureValid = validateAPIKeySignature(keyData, signature, expectations);
  if (!isSignatureValid) {
    return {
      isValid: false,
      message: "Invalid API key. Failed to validate signature"
    };
  }
  const [projectId] = keyDataWithoutPrefix.split(".");
  return _chunkF45I5NLIcjs.__spreadProps.call(void 0, _chunkF45I5NLIcjs.__spreadValues.call(void 0, {}, prefixValidationResult), {
    projectId
  });
}
function decodeAPIKeyAndGetParts(apiKey, prefix) {
  const base58EncodedPart = apiKey.slice(`${prefix}_`.length);
  const decodedPartUint8 = _bs582.default.decode(base58EncodedPart);
  const decodedPartString = new TextDecoder().decode(decodedPartUint8);
  const [keyDataWithoutPrefix, signature] = decodedPartString.split(":");
  const keyData = `${prefix}.${keyDataWithoutPrefix}`;
  return {
    keyData,
    keyDataWithoutPrefix,
    signature
  };
}
function validateAPIKeySignature(keyData, signature, expectations) {
  const expectedPublicKey = _chunk3LUTBWSJcjs.environmentToExpectedPublicKey.call(void 0, expectations == null ? void 0 : expectations.environment);
  function _validateSignature(expectedPublicKey2) {
    try {
      const signatureBytes = _bs582.default.decode(signature);
      const keyDataBytes = new TextEncoder().encode(keyData);
      const publicKeyBytes = _bs582.default.decode(expectedPublicKey2);
      return _tweetnacl2.default.sign.detached.verify(keyDataBytes, signatureBytes, publicKeyBytes);
    } catch (e) {
      console.error("Failed to validate API key signature");
      return false;
    }
  }
  if (expectedPublicKey != null) {
    return _validateSignature(expectedPublicKey);
  }
  return _validateSignature(_chunkV7MQGQOHcjs.CROSSMINT_API_KEY_SIGNER_PUBLICKEY_PROD) || _validateSignature(_chunkV7MQGQOHcjs.CROSSMINT_API_KEY_SIGNER_PUBLICKEY_STAGING);
}

// src/apiKey/utils/validateApiKeyAndGetCrossmintBaseUrl.ts
var urlMap = {
  development: _chunkV7MQGQOHcjs.CROSSMINT_DEV_URL,
  staging: _chunkV7MQGQOHcjs.CROSSMINT_STG_URL,
  production: _chunkV7MQGQOHcjs.CROSSMINT_PROD_URL
};
function validateApiKeyAndGetCrossmintBaseUrl(apiKey) {
  const result = validateAPIKey(apiKey);
  if (!result.isValid) {
    throw new Error("Crossmint API key is invalid");
  }
  return urlMap[result.environment];
}






exports.validateApiKeyAndGetCrossmintBaseUrl = validateApiKeyAndGetCrossmintBaseUrl; exports.validateAPIKeyPrefix = validateAPIKeyPrefix; exports.getEnvironmentForKey = getEnvironmentForKey; exports.validateAPIKey = validateAPIKey;
//# sourceMappingURL=chunk-TTUIUZ5Y.cjs.map