import {
  EVMBlockchain,
  EVMBlockchainTestnet,
  EVM_BLOCKCHAINS_INCLUDING_TESTNETS
} from "./chunk-2VTVPORR.js";
import {
  objectValues
} from "./chunk-7GKZNQO7.js";
import {
  __spreadValues
} from "./chunk-JPRRZPBL.js";

// src/blockchain/utils/isBlockchain.ts
function isBlockchain(value, expectedBlockchain) {
  return expectedBlockchain ? value === expectedBlockchain : BLOCKCHAINS.includes(value);
}

// src/blockchain/utils/isBlockchainIncludingTestnets.ts
function isBlockchainIncludingTestnets(value, expectedBlockchain) {
  return expectedBlockchain ? value === expectedBlockchain : BLOCKCHAINS_INCLUDING_TESTNETS.includes(value);
}

// src/blockchain/utils/evm/isEVMBlockchain.ts
function isEVMBlockchain(value) {
  return EVM_BLOCKCHAINS_INCLUDING_TESTNETS.some((chain) => isBlockchainIncludingTestnets(value, chain));
}

// src/blockchain/types/index.ts
var Blockchain = __spreadValues({
  SOLANA: "solana",
  CARDANO: "cardano",
  SUI: "sui",
  APTOS: "aptos"
}, EVMBlockchain);
var BLOCKCHAINS = objectValues(Blockchain);
var BlockchainTestnet = __spreadValues({}, EVMBlockchainTestnet);
var BLOCKCHAIN_TESTNETS = objectValues(BlockchainTestnet);
var BlockchainIncludingTestnet = __spreadValues(__spreadValues({}, Blockchain), BlockchainTestnet);
var BLOCKCHAINS_INCLUDING_TESTNETS = objectValues(BlockchainIncludingTestnet);

export {
  Blockchain,
  BLOCKCHAINS,
  BlockchainTestnet,
  BLOCKCHAIN_TESTNETS,
  BlockchainIncludingTestnet,
  BLOCKCHAINS_INCLUDING_TESTNETS,
  isBlockchain,
  isBlockchainIncludingTestnets,
  isEVMBlockchain
};
//# sourceMappingURL=chunk-YRM2GPBD.js.map